<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="API documentation for the Rust `CryptoRng` trait in crate `rand`."><meta name="keywords" content="rust, rustlang, rust-lang, CryptoRng"><title>rand::CryptoRng - Rust</title><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../dark.css"><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script src="../storage.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="shortcut icon" href="https://www.rust-lang.org/favicon.ico"><style type="text/css">#crate-search{background-image:url("../down-arrow.svg");}</style></head><body class="rustdoc trait"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../rand/index.html'><div class='logo-container'><img src='https://www.rust-lang.org/logos/rust-logo-128x128-blk.png' alt='logo'></div></a><p class='location'>Trait CryptoRng</p><div class="sidebar-elems"><div class="block items"><a class="sidebar-title" href="#foreign-impls">Implementations on Foreign Types</a><div class="sidebar-links"><a href="#impl-CryptoRng-for-%26%27a%20mut%20R">&amp;&#39;a mut R</a><a href="#impl-CryptoRng-for-BlockRng%3CR%3E">BlockRng&lt;R&gt;</a><a href="#impl-CryptoRng-for-Box%3CR%3E">Box&lt;R&gt;</a><a href="#impl-CryptoRng-for-ChaCha12Core">ChaCha12Core</a><a href="#impl-CryptoRng-for-ChaCha12Rng">ChaCha12Rng</a><a href="#impl-CryptoRng-for-ChaCha20Core">ChaCha20Core</a><a href="#impl-CryptoRng-for-ChaCha20Rng">ChaCha20Rng</a><a href="#impl-CryptoRng-for-ChaCha8Core">ChaCha8Core</a><a href="#impl-CryptoRng-for-ChaCha8Rng">ChaCha8Rng</a></div><a class="sidebar-title" href="#implementors">Implementors</a></div><p class='location'><a href='index.html'>rand</a></p><script>window.sidebarCurrent = {name: 'CryptoRng', ty: 'trait', relpath: ''};</script><script defer src="sidebar-items.js"></script></div></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../settings.html"><img src="../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><h1 class='fqn'><span class='out-of-band'><span id='render-detail'><a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class='inner'>&#x2212;</span>]</a></span><a class='srclink' href='../src/rand_core/lib.rs.html#208' title='goto source code'>[src]</a></span><span class='in-band'>Trait <a href='index.html'>rand</a>::<wbr><a class="trait" href=''>CryptoRng</a></span></h1><div class="docblock type-decl hidden-by-usual-hider"><pre class='rust trait'>pub trait CryptoRng { }</pre></div><div class='docblock'><p>A marker trait used to indicate that an [<code>RngCore</code>] or <a href="block::BlockRngCore"><code>BlockRngCore</code></a>
implementation is supposed to be cryptographically secure.</p>
<p><em>Cryptographically secure generators</em>, also known as <em>CSPRNGs</em>, should
satisfy an additional properties over other generators: given the first
<em>k</em> bits of an algorithm's output
sequence, it should not be possible using polynomial-time algorithms to
predict the next bit with probability significantly greater than 50%.</p>
<p>Some generators may satisfy an additional property, however this is not
required by this trait: if the CSPRNG's state is revealed, it should not be
computationally-feasible to reconstruct output prior to this. Some other
generators allow backwards-computation and are consided <em>reversible</em>.</p>
<p>Note that this trait is provided for guidance only and cannot guarantee
suitability for cryptographic applications. In general it should only be
implemented for well-reviewed code implementing well-regarded algorithms.</p>
<p>Note also that use of a <code>CryptoRng</code> does not protect against other
weaknesses such as seeding from a weak entropy source or leaking state.</p>
</div>
            <h2 id='foreign-impls' class='small-section-header'>Implementations on Foreign Types<a href='#foreign-impls' class='anchor'></a></h2><h3 id='impl-CryptoRng-for-%26%27a%20mut%20R' class='impl'><code class='in-band'>impl&lt;'a, R&gt; <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> for <a class="primitive" href="https://doc.rust-lang.org/nightly/std/primitive.reference.html">&amp;'a mut </a>R <span class="where fmt-newline">where<br>&nbsp;&nbsp;&nbsp;&nbsp;R: <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> + ?<a class="trait" href="https://doc.rust-lang.org/nightly/core/marker/trait.Sized.html" title="trait core::marker::Sized">Sized</a>,&nbsp;</span></code><a href='#impl-CryptoRng-for-%26%27a%20mut%20R' class='anchor'></a><a class='srclink' href='../src/rand_core/lib.rs.html#445' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-for-BlockRng%3CR%3E' class='impl'><code class='in-band'>impl&lt;R&gt; <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> for <a class="struct" href="../rand_core/block/struct.BlockRng.html" title="struct rand_core::block::BlockRng">BlockRng</a>&lt;R&gt; <span class="where fmt-newline">where<br>&nbsp;&nbsp;&nbsp;&nbsp;R: <a class="trait" href="../rand_core/block/trait.BlockRngCore.html" title="trait rand_core::block::BlockRngCore">BlockRngCore</a> + <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a>,&nbsp;</span></code><a href='#impl-CryptoRng-for-BlockRng%3CR%3E' class='anchor'></a><a class='srclink' href='../src/rand_core/block.rs.html#437' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-for-Box%3CR%3E' class='impl'><code class='in-band'>impl&lt;R&gt; <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> for <a class="struct" href="https://doc.rust-lang.org/nightly/alloc/boxed/struct.Box.html" title="struct alloc::boxed::Box">Box</a>&lt;R&gt; <span class="where fmt-newline">where<br>&nbsp;&nbsp;&nbsp;&nbsp;R: <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> + ?<a class="trait" href="https://doc.rust-lang.org/nightly/core/marker/trait.Sized.html" title="trait core::marker::Sized">Sized</a>,&nbsp;</span></code><a href='#impl-CryptoRng-for-Box%3CR%3E' class='anchor'></a><a class='srclink' href='../src/rand_core/lib.rs.html#449' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-for-ChaCha20Core' class='impl'><code class='in-band'>impl <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> for <a class="struct" href="../rand_chacha/chacha/struct.ChaCha20Core.html" title="struct rand_chacha::chacha::ChaCha20Core">ChaCha20Core</a></code><a href='#impl-CryptoRng-for-ChaCha20Core' class='anchor'></a><a class='srclink' href='../src/rand_chacha/chacha.rs.html#103' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-for-ChaCha12Core' class='impl'><code class='in-band'>impl <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> for <a class="struct" href="../rand_chacha/chacha/struct.ChaCha12Core.html" title="struct rand_chacha::chacha::ChaCha12Core">ChaCha12Core</a></code><a href='#impl-CryptoRng-for-ChaCha12Core' class='anchor'></a><a class='srclink' href='../src/rand_chacha/chacha.rs.html#103' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-for-ChaCha20Rng' class='impl'><code class='in-band'>impl <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> for <a class="struct" href="../rand_chacha/chacha/struct.ChaCha20Rng.html" title="struct rand_chacha::chacha::ChaCha20Rng">ChaCha20Rng</a></code><a href='#impl-CryptoRng-for-ChaCha20Rng' class='anchor'></a><a class='srclink' href='../src/rand_chacha/chacha.rs.html#235' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-for-ChaCha8Rng' class='impl'><code class='in-band'>impl <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> for <a class="struct" href="../rand_chacha/chacha/struct.ChaCha8Rng.html" title="struct rand_chacha::chacha::ChaCha8Rng">ChaCha8Rng</a></code><a href='#impl-CryptoRng-for-ChaCha8Rng' class='anchor'></a><a class='srclink' href='../src/rand_chacha/chacha.rs.html#235' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-for-ChaCha8Core' class='impl'><code class='in-band'>impl <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> for <a class="struct" href="../rand_chacha/chacha/struct.ChaCha8Core.html" title="struct rand_chacha::chacha::ChaCha8Core">ChaCha8Core</a></code><a href='#impl-CryptoRng-for-ChaCha8Core' class='anchor'></a><a class='srclink' href='../src/rand_chacha/chacha.rs.html#103' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-for-ChaCha12Rng' class='impl'><code class='in-band'>impl <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a> for <a class="struct" href="../rand_chacha/chacha/struct.ChaCha12Rng.html" title="struct rand_chacha::chacha::ChaCha12Rng">ChaCha12Rng</a></code><a href='#impl-CryptoRng-for-ChaCha12Rng' class='anchor'></a><a class='srclink' href='../src/rand_chacha/chacha.rs.html#235' title='goto source code'>[src]</a></h3><div class='impl-items'></div><span class='loading-content'>Loading content...</span>
            <h2 id='implementors' class='small-section-header'>Implementors<a href='#implementors' class='anchor'></a></h2><div class='item-list' id='implementors-list'><h3 id='impl-CryptoRng' class='impl'><code class='in-band'>impl CryptoRng for <a class="struct" href="../rand/rngs/struct.EntropyRng.html" title="struct rand::rngs::EntropyRng">EntropyRng</a></code><a href='#impl-CryptoRng' class='anchor'></a><a class='srclink' href='../src/rand/rngs/entropy.rs.html#63' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-1' class='impl'><code class='in-band'>impl CryptoRng for <a class="struct" href="../rand/rngs/struct.OsRng.html" title="struct rand::rngs::OsRng">OsRng</a></code><a href='#impl-CryptoRng-1' class='anchor'></a><a class='srclink' href='../src/rand_core/os.rs.html#50' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-2' class='impl'><code class='in-band'>impl CryptoRng for <a class="struct" href="../rand/rngs/struct.StdRng.html" title="struct rand::rngs::StdRng">StdRng</a></code><a href='#impl-CryptoRng-2' class='anchor'></a><a class='srclink' href='../src/rand/rngs/std.rs.html#74' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-3' class='impl'><code class='in-band'>impl CryptoRng for <a class="struct" href="../rand/rngs/struct.ThreadRng.html" title="struct rand::rngs::ThreadRng">ThreadRng</a></code><a href='#impl-CryptoRng-3' class='anchor'></a><a class='srclink' href='../src/rand/rngs/thread.rs.html#112' title='goto source code'>[src]</a></h3><div class='impl-items'></div><h3 id='impl-CryptoRng-4' class='impl'><code class='in-band'>impl&lt;R, Rsdr&gt; CryptoRng for <a class="struct" href="../rand/rngs/adapter/struct.ReseedingRng.html" title="struct rand::rngs::adapter::ReseedingRng">ReseedingRng</a>&lt;R, Rsdr&gt; <span class="where fmt-newline">where<br>&nbsp;&nbsp;&nbsp;&nbsp;R: <a class="trait" href="../rand_core/block/trait.BlockRngCore.html" title="trait rand_core::block::BlockRngCore">BlockRngCore</a> + <a class="trait" href="../rand/trait.SeedableRng.html" title="trait rand::SeedableRng">SeedableRng</a> + <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a>,<br>&nbsp;&nbsp;&nbsp;&nbsp;Rsdr: <a class="trait" href="../rand/trait.RngCore.html" title="trait rand::RngCore">RngCore</a> + <a class="trait" href="../rand/trait.CryptoRng.html" title="trait rand::CryptoRng">CryptoRng</a>,&nbsp;</span></code><a href='#impl-CryptoRng-4' class='anchor'></a><a class='srclink' href='../src/rand/rngs/adapter/reseeding.rs.html#143-148' title='goto source code'>[src]</a></h3><div class='impl-items'></div></div><span class='loading-content'>Loading content...</span><script type="text/javascript" src="../implementors/rand_core/trait.CryptoRng.js" async></script></section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../";window.currentCrate = "rand";</script><script src="../main.js"></script><script defer src="../search-index.js"></script></body></html>